function tribeExpandedFrame_OnLoad()
  local frame = TribeExpandedFrame
  tinsert(UISpecialFrames, frame:GetName())
  
  
  -- Make sure no more than one setting screen is open at the same time.
  npcGenerator_NPC_Frame.Tribe.ExpandButton:SetScript("OnClick", function()
    if frame:IsVisible() then
      frame:Hide()
    else
      if frame:GetParent().activeExpandedFrame then
        frame:GetParent().activeExpandedFrame:Hide()
      end
      frame:GetParent().activeExpandedFrame = frame
      frame:Show()
    end
  end)
  
  frame.Panel.ContextToggle:HookScript("PostClick", function(self, button, down)
    if self:GetChecked() then
      NPCG_Options.tribeSettings.factionMatchingMode = "Context-based"
    else
      NPCG_Options.tribeSettings.factionMatchingMode = "Faction-based"  -- This cannot be clicked when faction forcing is disabled, so no need to check.
    end
  end)
    
  frame.Panel.ForceFactionToggle:HookScript("PostClick", function(self, button, down)
    if self:GetChecked() and frame.Panel.ContextToggle:GetChecked() then
      NPCG_Options.tribeSettings.factionMatchingMode = "Context-based"
    elseif self:GetChecked() then -- Only faction matching, but no context matching.  
      NPCG_Options.tribeSettings.factionMatchingMode = "Faction-based"
    else
      NPCG_Options.tribeSettings.factionMatchingMode = "All"
    end
  end)
end