local tribes = { }
--tribes["blood elf"]     = { [ ""            ] = { weight = 1, faction =    "horde" } }
tribes["death knight"]  = { [ "blood elf"   ] = { weight = 1, faction =    "horde" },
                            [ "draenei"     ] = { weight = 1, faction = "alliance" },
                            [ "dwarf"       ] = { weight = 1, faction = "alliance" },
                            [ "gnome"       ] = { weight = 1, faction = "alliance" },
                            [ "goblin"      ] = { weight = 1, faction =    "horde" },
                            [ "half elf"    ] = { weight = 1, faction =  "neutral" },
                            [ "high elf"    ] = { weight = 1, faction = "alliance" },
                            [ "human"       ] = { weight = 1, faction = "alliance" },
                            [ "night elf"   ] = { weight = 1, faction = "alliance" },
                            [ "orc"         ] = { weight = 1, faction =    "horde" },
                            [ "tauren"      ] = { weight = 1, faction =    "horde" },
                            [ "troll"       ] = { weight = 1, faction =    "horde" },
                            [ "worgen"      ] = { weight = 1, faction = "alliance" } }
--tribes["draenei"]       = { [ ""            ] = { weight = 1, faction = "alliance" } }
tribes["dwarf"]         = { [ "dark iron"   ] = { weight = 1, faction = "alliance" },
                            [ "wildhammer"  ] = { weight = 1, faction = "alliance" },
                            [ "bronzebeard" ] = { weight = 1, faction = "alliance" },
                            [ "frostborn"   ] = { weight = 1, faction = "alliance" },
                            [ "stonefist"   ] = { weight = 1, faction = "alliance" },
                            [ "stormpike"   ] = { weight = 1, faction = "alliance" } }
--tribes["gnome"]         = { [ ""            ] = { weight = 1, faction = "alliance" } }
--tribes["goblin"]        = { [ ""            ] = { weight = 1, faction = "alliance" } }
--tribes["half elf"]      = { [ ""            ] = { weight = 1, faction =  "neutral" } }
--tribes["half orc"]      = { [ ""            ] = { weight = 1, faction =  "neutral" } }
--tribes["high elf"]      = { [ ""            ] = { weight = 1, faction = "alliance" } }
--tribes["human"]         = { [ ""            ] = { weight = 1, faction = "alliance" } }
tribes["night elf"]     = { [ "kaldorei"    ] = { weight = 8, faction = "alliance" },
                            [ "highborne"   ] = { weight = 1, faction = "alliance" } }
--mergeTables(replicate(8, "kaldorei"), { "highborne" })
tribes["orc"]           = { [ "fel"         ] = { weight = 1, faction =    "horde" },
                            [ "brown"       ] = { weight = 1, faction =    "horde" } }
tribes["pandaren"]      = { [ "huojin"      ] = { weight = 1, faction =    "horde" },
                            [ "tushui"      ] = { weight = 1, faction = "alliance" },
                            [ "independant" ] = { weight = 1, faction =  "neutral" } }
tribes["tauren"]        = { [ "bloodhoof"   ] = { weight = 1, faction =    "horde" },
                            [ "dawnstrider" ] = { weight = 1, faction =    "horde" },
                            [ "grimtotem"   ] = { weight = 1, faction =    "horde" },
                            [ "mistrunner"  ] = { weight = 1, faction =    "horde" },
                            [ "ragetotem"   ] = { weight = 1, faction =    "horde" },
                            [ "runetotem"   ] = { weight = 1, faction =    "horde" },
                            [ "skychaser"   ] = { weight = 1, faction =    "horde" },
                            [ "stonehoof"   ] = { weight = 1, faction =    "horde" },
                            [ "thunderhorn" ] = { weight = 1, faction =    "horde" },
                            [ "wildmane"    ] = { weight = 1, faction =    "horde" },
                            [ "winterhoof"  ] = { weight = 1, faction =    "horde" },
                            [ "clawhoof"    ] = { weight = 1, faction =    "horde" } }
tribes["troll"]         = { [ "island"      ] = { weight = 1, faction =    "horde" },
                            [ "forest"      ] = { weight = 1, faction =    "horde" },
                            [ "jungle"      ] = { weight = 1, faction =    "horde" },
                            [ "ice"         ] = { weight = 1, faction =    "horde" },
                            [ "desert"      ] = { weight = 1, faction =    "horde" },
                            [ ""            ] = { weight = 1, faction =    "horde" } }
tribes["undead"]        = { [ "blood elf"   ] = { weight = 1, faction =    "horde" },
                            [ "high elf"    ] = { weight = 2, faction =    "horde" },
                            [ "human"       ] = { weight = 7, faction =    "horde" } }
--mergeTables(replicate(7, "human"), replicate(2, "high elf"), replicate(1, "blood elf"))
--tribes["worgen"]        = { [ ""            ] = { weight = 1, faction = "alliance" } }

zonesToTribes = { } -- merge these with exisiting?
zonesToTribes["Thunder Totem"] = {  
    [   "tauren"] = mergeTables2({ ["highmountain"] = { weight = 30, faction =  "neutral" } }, tribes[   "tauren"]) }
zonesToTribes[ "Highmountain"] = zonesToTribes["Thunder Totem"]
zonesToTribes[      "Suramar"] = {
    ["night elf"] = mergeTables2({ ["nightfallen"]  = { weight =  2, faction =  "neutral" } }, tribes["night elf"]) }
--mergeTables(replicate( 6,     "kaldorei"), { "highborne", "nightfallen" } )

-- Name displayed for the Tribe trait.
local context	= { 
  ["blood elf"    ] = "",
  ["death knight" ] = "Died as",
  ["draenei"      ] = "",
  ["dwarf"        ] = "Clan",
  ["gnome"        ] = "",
  ["goblin"       ] = "",
  ["half elf"     ] = "",
  ["half orc"     ] = "",
  ["high elf"     ] = "",
  ["human"        ] = "",
  ["night elf"    ] = "Type",
  ["orc"          ] = "Clan",
  ["pandaren"     ] = "Faction",
  ["tauren"       ] = "Clan",
  ["troll"        ] = "Subrace",
  ["undead"       ] = "Died as",
  ["worgen"       ] = ""
}

local function isTribeOfFaction(race, tribe)
  if not tribes[race]        then return true  end
  if not tribes[race][tribe] then return true  end
  return tribes[race][tribe].faction == string.lower(UnitFactionGroup("player")) or tribes[race][tribe].faction == "neutral"
end

local function isTribeWithinContext(race, tribe)
  if GetZoneText() == "Suramar" then
     return isTribeOfFaction(race, tribe) or (race == "night elf" and tribe == "nightfallen")
  else
    return isTribeOfFaction(race, tribe)
  end
end

-- generateRandomTribe :: Race a => a -> Tribe
function generateRandomTribe(characterTemplate)
  local selectionList = 
    -- Zone-based selection.
    (zonesToTribes[GetZoneText()] or tribes)[characterTemplate.race]
    -- Fallback to default selection.
    or tribes[characterTemplate.race]
    -- Fallback to empty.
    or { [""] = { weight=1,faction="neutral" } }
  
  if     NPCG_Options.tribeSettings.factionMatchingMode == "Faction-based" then
    selectionList = filter2(function(tribe) return isTribeOfFaction(    characterTemplate.race, tribe) end, selectionList)
  elseif NPCG_Options.tribeSettings.factionMatchingMode == "Context-based" then
    selectionList = filter2(function(tribe) return isTribeWithinContext(characterTemplate.race, tribe) end, selectionList)
  end

  return weightedRandomFrom(keys(selectionList), function(x) return selectionList[x].weight end)
  --if not tribes[characterTemplate.race] then return "" end
  --return randomFrom((zonesToTribes[GetZoneText()] or tribes)[characterTemplate:getRace()] or tribes[characterTemplate:getRace()]) or "Error: No options found!"
end

-- getTribeContext :: Race -> string
function getTribeContext(race)
	return context[race] or ""
end